/*
    cap_ctrl Task
    超级电容
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "device/supercap.h"
#include "module/cap.h"
#include "device/motor_rm.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
chassis_move_t ch;
CAN_SuperCapTXDataTypeDef SuperCap_CanTX;

/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_cap_ctrl(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / CAP_CTRL_FREQ;

  osDelay(CAP_CTRL_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
	
	BSP_CAN_Init();
	
	SuperCap_Init();
	SuperCap_CanTX.Enable = 1 ; 				//超级电容使能。1使能，0失能
  SuperCap_CanTX.Charge = 1 ; 				//V1.1超级电容充电。1充电，0放电，在PLUS版本中，此标志位无效，超电的充放电是自动的
  SuperCap_CanTX.Powerlimit = 0 ;  		//裁判系统功率限制
  SuperCap_CanTX.ChargePower = 1 ; 		//V1.1超级电容充电功率，在PLUS版本中，此参数，超电的充电功率随着底盘功率变化
	
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
		/*
		
				散热
				
				
				
				
		*/
		SuperCap_Update();
		
		chassis_power_control_with_supercap(&ch);
		
		CAN_TX_SuperCapData(&SuperCap_CanTX);
		
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}